diff a/test/jdk/java/lang/Thread/virtual/MiscMonitorTests.java b/test/jdk/java/lang/Thread/virtual/MiscMonitorTests.java
--- /dev/null
+++ b/test/jdk/java/lang/Thread/virtual/MiscMonitorTests.java
@@ -0,0 +1,509 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test id=default
+ * @summary Tests for object monitors that have been useful to find bugs
+ * @library /test/lib
+ * @requires vm.continuations & vm.opt.LockingMode != 1
+ * @modules java.base/java.lang:+open
+ * @run junit/othervm MiscMonitorTests
+ */
+
+/*
+ * @test id=Xint
+ * @library /test/lib
+ * @requires vm.continuations & vm.opt.LockingMode != 1
+ * @modules java.base/java.lang:+open
+ * @run junit/othervm -Xint MiscMonitorTests
+ */
+
+/*
+ * @test id=Xcomp
+ * @library /test/lib
+ * @requires vm.continuations & vm.opt.LockingMode != 1
+ * @modules java.base/java.lang:+open
+ * @run junit/othervm -Xcomp MiscMonitorTests
+ */
+
+/*
+ * @test id=Xcomp-TieredStopAtLevel3
+ * @library /test/lib
+ * @requires vm.continuations & vm.opt.LockingMode != 1
+ * @modules java.base/java.lang:+open
+ * @run junit/othervm -Xcomp -XX:TieredStopAtLevel=3 MiscMonitorTests
+ */
+
+/*
+ * @test id=Xcomp-noTieredCompilation
+ * @summary Test virtual threads using synchronized
+ * @library /test/lib
+ * @requires vm.continuations & vm.opt.LockingMode != 1
+ * @modules java.base/java.lang:+open
+ * @run junit/othervm -Xcomp -XX:-TieredCompilation MiscMonitorTests
+ */
+
+/*
+ * @test id=gc
+ * @requires vm.debug == true & vm.continuations & vm.opt.LockingMode != 1
+ * @library /test/lib
+ * @modules java.base/java.lang:+open
+ * @run junit/othervm -XX:+UnlockDiagnosticVMOptions -XX:+FullGCALot -XX:FullGCALotInterval=1000 MiscMonitorTests
+ */
+
+import java.util.concurrent.atomic.AtomicInteger;
+import java.util.concurrent.*;
+import java.util.ArrayList;
+import java.util.List;
+
+import jdk.test.lib.thread.VThreadScheduler;
+import org.junit.jupiter.api.Test;
+import static org.junit.jupiter.api.Assertions.*;
+
+class MiscMonitorTests {
+    static final int CARRIER_COUNT = Runtime.getRuntime().availableProcessors();
+
+    /**
+     * Test that yielding while holding monitors releases carrier.
+     */
+    @Test
+    void testReleaseOnYield() throws Exception {
+        try (var test = new TestReleaseOnYield()) {
+            test.runTest();
+        }
+    }
+
+    private static class TestReleaseOnYield extends TestBase {
+        final Object lock = new Object();
+        volatile boolean finish;
+        volatile int counter;
+
+        @Override
+        void runTest() throws Exception {
+            int vthreadCount = CARRIER_COUNT;
+
+            startVThreads(() -> foo(), vthreadCount, "Batch1");
+            sleep(500);  // Give time for threads to reach Thread.yield
+            startVThreads(() -> bar(), vthreadCount, "Batch2");
+
+            while (counter != vthreadCount) {
+                Thread.onSpinWait();
+            }
+            finish = true;
+            joinVThreads();
+        }
+
+        void foo() {
+            Object lock = new Object();
+            synchronized (lock) {
+                while (!finish) {
+                    Thread.yield();
+                }
+            }
+            System.err.println("Exiting foo from thread " + Thread.currentThread().getName());
+        }
+
+        void bar() {
+            synchronized (lock) {
+                counter++;
+            }
+            System.err.println("Exiting bar from thread " + Thread.currentThread().getName());
+        }
+    }
+
+    /**
+     * Test yielding while holding monitors with recursive locking releases carrier.
+     */
+    @Test
+    void testReleaseOnYieldRecursive() throws Exception {
+        try (var test = new TestReleaseOnYieldRecursive()) {
+            test.runTest();
+        }
+    }
+
+    private static class TestReleaseOnYieldRecursive extends TestBase {
+        final Object lock = new Object();
+        volatile boolean finish;
+        volatile int counter;
+
+        @Override
+        void runTest() throws Exception {
+            int vthreadCount = CARRIER_COUNT;
+
+            startVThreads(() -> foo(), vthreadCount, "Batch1");
+            sleep(500);  // Give time for threads to reach Thread.yield
+            startVThreads(() -> bar(), vthreadCount, "Batch2");
+
+            while (counter != 2 * vthreadCount) {
+                Thread.onSpinWait();
+            }
+            finish = true;
+            joinVThreads();
+        }
+
+        void foo() {
+           Object lock = new Object();
+            synchronized (lock) {
+                while (!finish) {
+                    Thread.yield();
+                }
+            }
+            System.err.println("Exiting foo from thread " + Thread.currentThread().getName());
+        }
+
+        void bar() {
+            synchronized (lock) {
+                counter++;
+            }
+            recursive(10);
+            System.err.println("Exiting bar from thread " + Thread.currentThread().getName());
+        };
+
+        void recursive(int count) {
+            synchronized (Thread.currentThread()) {
+                if (count > 0) {
+                    recursive(count - 1);
+                } else {
+                    synchronized (lock) {
+                        counter++;
+                        Thread.yield();
+                    }
+                }
+            }
+        }
+    }
+
+    /**
+     * Test that contention on monitorenter releases carrier.
+     */
+    @Test
+    void testReleaseOnContention() throws Exception {
+        try (var test = new TestReleaseOnContention()) {
+            test.runTest();
+        }
+    }
+
+    private static class TestReleaseOnContention extends TestBase {
+        final Object lock = new Object();
+        volatile boolean finish;
+        volatile int counter;
+
+        @Override
+        void runTest() throws Exception {
+            int vthreadCount = CARRIER_COUNT * 8;
+
+            startVThreads(() -> foo(), vthreadCount, "VThread");
+            sleep(500);  // Give time for threads to reach synchronized (lock)
+
+            finish = true;
+            joinVThreads();
+        }
+
+        void foo() {
+            synchronized (lock) {
+                while (!finish) {
+                    Thread.yield();
+                }
+            }
+            System.err.println("Exiting foo from thread " + Thread.currentThread().getName());
+        }
+    }
+
+    /**
+     * Test contention on monitorenter with extra monitors on stack shared by all threads.
+     */
+    @Test
+    void testContentionMultipleMonitors() throws Exception {
+        try (var test = new TestContentionMultipleMonitors()) {
+            test.runTest();
+        }
+    }
+
+    private static class TestContentionMultipleMonitors extends TestBase {
+        static int MONITOR_COUNT = 12;
+        final Object[] lockArray = new Object[MONITOR_COUNT];
+        final AtomicInteger workerCount = new AtomicInteger(0);
+        volatile boolean finish;
+
+        @Override
+        void runTest() throws Exception {
+            int vthreadCount = CARRIER_COUNT * 8;
+            for (int i = 0; i < MONITOR_COUNT; i++) {
+                lockArray[i] = new Object();
+            }
+
+            startVThreads(() -> foo(), vthreadCount, "VThread");
+
+            sleep(5000);
+            finish = true;
+            joinVThreads();
+            assertEquals(vthreadCount, workerCount.get());
+        }
+
+        void foo() {
+            while (!finish) {
+                int lockNumber = ThreadLocalRandom.current().nextInt(0, MONITOR_COUNT - 1);
+                synchronized (lockArray[lockNumber]) {
+                    recursive1(lockNumber, lockNumber);
+                }
+            }
+            workerCount.getAndIncrement();
+            System.err.println("Exiting foo from thread " + Thread.currentThread().getName());
+        }
+
+        public void recursive1(int depth, int lockNumber) {
+            if (depth > 0) {
+                recursive1(depth - 1, lockNumber);
+            } else {
+                if (Math.random() < 0.5) {
+                    Thread.yield();
+                }
+                recursive2(lockNumber);
+            }
+        }
+
+        public void recursive2(int lockNumber) {
+            if (lockNumber + 2 <= MONITOR_COUNT - 1) {
+                lockNumber += 2;
+                synchronized (lockArray[lockNumber]) {
+                    Thread.yield();
+                    recursive2(lockNumber);
+                }
+            }
+        }
+    }
+
+    /**
+     * Test contention on monitorenter with extra monitors on stack both local only and shared by all threads.
+     */
+    @Test
+    void testContentionMultipleMonitors2() throws Exception {
+        try (var test = new TestContentionMultipleMonitors2()) {
+            test.runTest();
+        }
+    }
+
+    private static class TestContentionMultipleMonitors2 extends TestBase {
+        int MONITOR_COUNT = 12;
+        final Object[] lockArray = new Object[MONITOR_COUNT];
+        final AtomicInteger workerCount = new AtomicInteger(0);
+        volatile boolean finish;
+
+        @Override
+        void runTest() throws Exception {
+            int vthreadCount = CARRIER_COUNT * 8;
+            for (int i = 0; i < MONITOR_COUNT; i++) {
+                lockArray[i] = new Object();
+            }
+
+            startVThreads(() -> foo(), vthreadCount, "VThread");
+
+            sleep(5000);
+            finish = true;
+            joinVThreads();
+            assertEquals(vthreadCount, workerCount.get());
+        }
+
+        void foo() {
+            Object[] myLockArray = new Object[MONITOR_COUNT];
+            for (int i = 0; i < MONITOR_COUNT; i++) {
+                myLockArray[i] = new Object();
+            }
+
+            while (!finish) {
+                int lockNumber = ThreadLocalRandom.current().nextInt(0, MONITOR_COUNT - 1);
+                synchronized (myLockArray[lockNumber]) {
+                    synchronized (lockArray[lockNumber]) {
+                        recursive1(lockNumber, lockNumber, myLockArray);
+                    }
+                }
+            }
+            workerCount.getAndIncrement();
+            System.err.println("Exiting foo from thread " + Thread.currentThread().getName());
+        }
+
+        public void recursive1(int depth, int lockNumber, Object[] myLockArray) {
+            if (depth > 0) {
+                recursive1(depth - 1, lockNumber, myLockArray);
+            } else {
+                if (Math.random() < 0.5) {
+                    Thread.yield();
+                }
+                recursive2(lockNumber, myLockArray);
+            }
+        }
+
+        public void recursive2(int lockNumber, Object[] myLockArray) {
+            if (lockNumber + 2 <= MONITOR_COUNT - 1) {
+                lockNumber += 2;
+                synchronized (myLockArray[lockNumber]) {
+                    if (Math.random() < 0.5) {
+                        Thread.yield();
+                    }
+                    synchronized (lockArray[lockNumber]) {
+                        Thread.yield();
+                        recursive2(lockNumber, myLockArray);
+                    }
+                }
+            }
+        }
+    }
+
+
+    /**
+     * Test contention on monitorenter with synchronized methods.
+     */
+    @Test
+    void testContentionWithSyncMethods() throws Exception {
+        try (var test = new TestContentionWithSyncMethods()) {
+            test.runTest();
+        }
+    }
+
+    private static class TestContentionWithSyncMethods extends TestBase {
+        static final int MONITOR_COUNT = 12;
+        final Object[] lockArray = new Object[MONITOR_COUNT];
+        final AtomicInteger workerCount = new AtomicInteger(0);
+        volatile boolean finish;
+
+        @Override
+        void runTest() throws Exception {
+            int vthreadCount = CARRIER_COUNT * 8;
+            for (int i = 0; i < MONITOR_COUNT; i++) {
+                lockArray[i] = new Object();
+            }
+
+            startVThreads(() -> foo(), vthreadCount, "VThread");
+
+            sleep(5000);
+            finish = true;
+            joinVThreads();
+            assertEquals(vthreadCount, workerCount.get());
+        }
+
+        void foo() {
+            Object myLock = new Object();
+
+            while (!finish) {
+                int lockNumber = ThreadLocalRandom.current().nextInt(0, MONITOR_COUNT - 1);
+                synchronized (myLock) {
+                    synchronized (lockArray[lockNumber]) {
+                        recursive(lockNumber, myLock);
+                    }
+                }
+            }
+            workerCount.getAndIncrement();
+            System.err.println("Exiting foo from thread " + Thread.currentThread().getName());
+        };
+
+        synchronized void recursive(int depth, Object myLock) {
+            if (depth > 0) {
+                recursive(depth - 1, myLock);
+            } else {
+                if (Math.random() < 0.5) {
+                    Thread.yield();
+                } else {
+                    synchronized (myLock) {
+                        Thread.yield();
+                    }
+                }
+            }
+        }
+    }
+
+    /**
+     * Test wait/notify mechanism.
+     */
+    @Test
+    void waitNotifyTest() throws Exception {
+        int threadCount = 1000;
+        int waitTime = 50;
+        Thread[] vthread = new Thread[threadCount];
+        long start = System.currentTimeMillis();
+
+        while (System.currentTimeMillis() - start < 5000) {
+            CountDownLatch latchStart = new CountDownLatch(threadCount);
+            CountDownLatch latchFinish = new CountDownLatch(threadCount);
+            Object object = new Object();
+
+            for (int i = 0; i < threadCount; i++) {
+                vthread[i] = Thread.ofVirtual().start(() -> {
+                    synchronized (object) {
+                        try {
+                            latchStart.countDown();
+                            object.wait(waitTime);
+                        } catch (InterruptedException e) {
+                            //do nothing;
+                        }
+                    }
+                    latchFinish.countDown();
+                });
+            }
+
+            try {
+                latchStart.await();
+                synchronized (object) {
+                    object.notifyAll();
+                }
+                latchFinish.await();
+                for (int i = 0; i < threadCount; i++) {
+                    vthread[i].join();
+                }
+            } catch (InterruptedException e) {
+                //do nothing;
+            }
+        }
+    }
+
+    private static abstract class TestBase implements AutoCloseable {
+        final ExecutorService scheduler = Executors.newFixedThreadPool(CARRIER_COUNT);
+        final List<Thread[]> vthreadList = new ArrayList<>();
+
+        abstract void runTest() throws Exception;
+
+        void startVThreads(Runnable r, int count, String name) {
+            Thread vthreads[] = new Thread[count];
+            for (int i = 0; i < count; i++) {
+                vthreads[i] = VThreadScheduler.virtualThreadBuilder(scheduler).name(name + "-" + i).start(r);
+            }
+            vthreadList.add(vthreads);
+        }
+
+        void joinVThreads() throws Exception {
+            for (Thread[] vthreads : vthreadList) {
+                for (Thread vthread : vthreads) {
+                    vthread.join();
+                }
+            }
+        }
+
+        void sleep(long ms) throws Exception {
+            Thread.sleep(ms);
+        }
+
+        @Override
+        public void close() {
+            scheduler.close();
+        }
+    }
+}
diff a/test/jdk/java/lang/Thread/virtual/MonitorEnterExit.java b/test/jdk/java/lang/Thread/virtual/MonitorEnterExit.java
--- a/test/jdk/java/lang/Thread/virtual/MonitorEnterExit.java
+++ b/test/jdk/java/lang/Thread/virtual/MonitorEnterExit.java
@@ -24,13 +24,94 @@
 /*
  * @test id=default
  * @summary Test virtual thread with monitor enter/exit
  * @modules java.base/java.lang:+open jdk.management
  * @library /test/lib
+ * @build LockingMode
  * @run junit/othervm --enable-native-access=ALL-UNNAMED MonitorEnterExit
  */
 
+/*
+ * @test id=LM_LEGACY
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -XX:LockingMode=1 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=LM_LIGHTWEIGHT
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -XX:LockingMode=2 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xint-LM_LEGACY
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xint -XX:LockingMode=1 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xint-LM_LIGHTWEIGHT
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xint -XX:LockingMode=2 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xcomp-LM_LEGACY
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xcomp -XX:LockingMode=1 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xcomp-LM_LIGHTWEIGHT
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xcomp -XX:LockingMode=2 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xcomp-TieredStopAtLevel1-LM_LEGACY
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xcomp -XX:TieredStopAtLevel=1 -XX:LockingMode=1 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xcomp-TieredStopAtLevel1-LM_LIGHTWEIGHT
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xcomp -XX:TieredStopAtLevel=1 -XX:LockingMode=2 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xcomp-noTieredCompilation-LM_LEGACY
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xcomp -XX:-TieredCompilation -XX:LockingMode=1 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
+/*
+ * @test id=Xcomp-noTieredCompilation-LM_LIGHTWEIGHT
+ * @modules java.base/java.lang:+open jdk.management
+ * @library /test/lib
+ * @build LockingMode
+ * @run junit/othervm -Xcomp -XX:-TieredCompilation -XX:LockingMode=2 --enable-native-access=ALL-UNNAMED MonitorEnterExit
+ */
+
 import java.time.Duration;
 import java.util.ArrayList;
 import java.util.List;
 import java.util.concurrent.CountDownLatch;
 import java.util.concurrent.ThreadFactory;
@@ -46,27 +127,26 @@
 import jdk.test.lib.thread.VThreadRunner;   // ensureParallelism requires jdk.management
 import jdk.test.lib.thread.VThreadScheduler;
 import org.junit.jupiter.api.Test;
 import org.junit.jupiter.api.BeforeAll;
 import org.junit.jupiter.api.RepeatedTest;
+import org.junit.jupiter.api.condition.DisabledIf;
 import org.junit.jupiter.params.ParameterizedTest;
 import org.junit.jupiter.params.provider.Arguments;
 import org.junit.jupiter.params.provider.ValueSource;
 import org.junit.jupiter.params.provider.MethodSource;
-import org.junit.jupiter.api.condition.*;
 import static org.junit.jupiter.api.Assertions.*;
 import static org.junit.jupiter.api.Assumptions.*;
 
 class MonitorEnterExit {
+    static final int MAX_VTHREAD_COUNT = 4 * Runtime.getRuntime().availableProcessors();
     static final int MAX_ENTER_DEPTH = 256;
 
     @BeforeAll
     static void setup() {
-        // need >=2 carriers for testing pinning when main thread is a virtual thread
-        if (Thread.currentThread().isVirtual()) {
-            VThreadRunner.ensureParallelism(2);
-        }
+        // need >=2 carriers for tests that pin
+        VThreadRunner.ensureParallelism(2);
     }
 
     /**
      * Test monitor enter with no contention.
      */
@@ -148,10 +228,57 @@
                 assertTrue(Thread.holdsLock(lock));
             }
         }
     }
 
+    /**
+     * Test monitor reenter when there are other threads blocked trying to enter.
+     */
+    @Test
+    @DisabledIf("LockingMode#isLegacy")
+    void testReenterWithContention() throws Exception {
+        var lock = new Object();
+        VThreadRunner.run(() -> {
+            List<Thread> threads = new ArrayList<>();
+            testReenter(lock, 0, threads);
+
+            // wait for threads to terminate
+            for (Thread vthread : threads) {
+                vthread.join();
+            }
+        });
+    }
+
+    private void testReenter(Object lock, int depth, List<Thread> threads) throws Exception {
+        if (depth < MAX_ENTER_DEPTH) {
+            synchronized (lock) {
+                assertTrue(Thread.holdsLock(lock));
+
+                // start platform or virtual thread that blocks waiting to enter
+                var started = new CountDownLatch(1);
+                ThreadFactory factory = ThreadLocalRandom.current().nextBoolean()
+                        ? Thread.ofPlatform().factory()
+                        : Thread.ofVirtual().factory();
+                var thread = factory.newThread(() -> {
+                    started.countDown();
+                    synchronized (lock) {
+                        /* do nothing */
+                    }
+                });
+                thread.start();
+
+                // wait for thread to start and block
+                started.await();
+                await(thread, Thread.State.BLOCKED);
+                threads.add(thread);
+
+                // test reenter
+                testReenter(lock, depth + 1, threads);
+            }
+        }
+    }
+
     /**
      * Test monitor enter when pinned.
      */
     @Test
     void testEnterWhenPinned() throws Exception {
@@ -195,17 +322,11 @@
     /**
      * Test contended monitor enter when pinned. Monitor is held by virtual thread.
      */
     @Test
     void testContendedEnterWhenPinnedHeldByVirtualThread() throws Exception {
-        // need at least two carrier threads
-        int previousParallelism = VThreadRunner.ensureParallelism(2);
-        try {
-            VThreadRunner.run(this::testEnterWithContentionWhenPinned);
-        } finally {
-            VThreadRunner.setParallelism(previousParallelism);
-        }
+        VThreadRunner.run(this::testEnterWithContentionWhenPinned);
     }
 
     /**
      * Test contended monitor enter when pinned, monitor will be held by caller thread.
      */
@@ -232,10 +353,83 @@
 
         // check thread entered monitor
         assertTrue(entered.get());
     }
 
+    /**
+     * Test that blocking waiting to enter a monitor releases the carrier.
+     */
+    @Test
+    @DisabledIf("LockingMode#isLegacy")
+    void testReleaseWhenBlocked() throws Exception {
+        assumeTrue(VThreadScheduler.supportsCustomScheduler(), "No support for custom schedulers");
+        try (ExecutorService scheduler = Executors.newFixedThreadPool(1)) {
+            ThreadFactory factory = VThreadScheduler.virtualThreadFactory(scheduler);
+
+            var lock = new Object();
+
+            // thread enters monitor
+            var started = new CountDownLatch(1);
+            var vthread1 = factory.newThread(() -> {
+                started.countDown();
+                synchronized (lock) {
+                }
+            });
+
+            try {
+                synchronized (lock) {
+                    // start thread and wait for it to block
+                    vthread1.start();
+                    started.await();
+                    await(vthread1, Thread.State.BLOCKED);
+
+                    // carrier should be released, use it for another thread
+                    var executed = new AtomicBoolean();
+                    var vthread2 = factory.newThread(() -> {
+                        executed.set(true);
+                    });
+                    vthread2.start();
+                    vthread2.join();
+                    assertTrue(executed.get());
+                }
+            } finally {
+                vthread1.join();
+            }
+        }
+    }
+
+    /**
+     * Test lots of virtual threads blocked waiting to enter a monitor. If the number
+     * of virtual threads exceeds the number of carrier threads this test will hang if
+     * carriers aren't released.
+     */
+    @Test
+    @DisabledIf("LockingMode#isLegacy")
+    void testManyBlockedThreads() throws Exception {
+        Thread[] vthreads = new Thread[MAX_VTHREAD_COUNT];
+        var lock = new Object();
+        synchronized (lock) {
+            for (int i = 0; i < MAX_VTHREAD_COUNT; i++) {
+                var started = new CountDownLatch(1);
+                var vthread = Thread.ofVirtual().start(() -> {
+                    started.countDown();
+                    synchronized (lock) {
+                    }
+                });
+                // wait for thread to start and block
+                started.await();
+                await(vthread, Thread.State.BLOCKED);
+                vthreads[i] = vthread;
+            }
+        }
+
+        // cleanup
+        for (int i = 0; i < MAX_VTHREAD_COUNT; i++) {
+            vthreads[i].join();
+        }
+    }
+
     /**
      * Returns a stream of elements that are ordered pairs of platform and virtual thread
      * counts. 0,2,4,..16 platform threads. 2,4,6,..32 virtual threads.
      */
     static Stream<Arguments> threadCounts() {
